unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.frm}

{ TForm1 }
Procedure ResizeJPeg(Const AJPegImage: TJPegImage; Const AWidth, AHeight: Integer);
Var
  ARect:    TRect;
  ATempJPeg: TJPegImage;
  X, Y:     Integer;
Begin
  If (AJPegImage.Width = AWidth) And (AJPegImage.Height = AHeight) Then Exit;

  FillChar(ARect, SizeOf(TRect), 0);
  If (AJPegImage.Width > AJPegImage.Height) Then
  Begin
    ARect.Right := AWidth;
    ARect.Bottom := ((AWidth * AJPegImage.Height) Div AJPegImage.Width);
    X := 0;
    Y := (AHeight Div 2) - (ARect.Bottom Div 2);
  End
  Else
  Begin
    ARect.Right := ((AHeight * AJPegImage.Width) Div AJPegImage.Height);
    ARect.Bottom := AHeight;
    X := (AWidth Div 2) - (ARect.Right Div 2);
    Y := 0;
  End;

  ATempJPeg := TJPegImage.Create;
  Try
    ATempJPeg.PixelFormat := AJPegImage.PixelFormat;
    ATempJPeg.Transparent := AJPegImage.Transparent;
    ATempJPeg.TransparentMode := AJPegImage.TransparentMode;
    ATempJPeg.TransparentColor := AJPegImage.TransparentColor;
    ATempJPeg.SetSize(AWidth, AHeight);
    ATempJPeg.Canvas.FillRect(ATempJPeg.Canvas.ClipRect);
    ATempJPeg.Canvas.StretchDraw(ARect, AJPegImage);

    AJPegImage.SetSize(AWidth, AHeight);
    AJPegImage.Canvas.FillRect(AJPegImage.Canvas.ClipRect);
    AJPegImage.Canvas.Draw(X, Y, ATempJPeg);
  Finally
    FreeAndNil(ATempJPeg);
  End;
End;

procedure TForm1.Button1Click(Sender: TObject);
Var
  AFileName : TFileName;
  AJPeg     : TJPegImage;
  AStream   : TMemoryStream;
Begin
  OpenDialog1.Filter:='JPEG Images (*.jpg)|*.jpg';
  If OpenDialog1.Execute Then  //  Just a dialog box to select a jpeg image
  Begin
    AFileName:=OpenDialog1.FileName;

    AJPeg := TJPegImage.Create;
    Try
      AJPeg.LoadFromFile(AFileName);

     ResizeJPeg(AJpeg, 200, 200);

      AJPeg.Canvas.Line(0,0,100,100);
      AJPeg.Canvas.FillRect(10,10,50,50);

      Image1.Picture.Assign(AJPeg);   //  resized image displays fine here
      AStream := TMemoryStream.Create;
      Try
        AJPeg.SaveToStream(AStream);  //  Here is the error "File not open."
      Finally
        FreeAndNil(AStream);
      End;
    Finally
      FreeAndNil(AJPeg);
    End;
  End;
End;

end.

